#!/usr/bin/perl

# (c) vbabin-at-ncsu-dot-edu 2010

use strict;
use warnings;
use POSIX qw(ceil floor);

my @cod;

while (<STDIN>) {
    my @toks = split;
    push @cod, $toks[1] if scalar @toks == 2;
}

die "** no data **\n" unless scalar @cod > 0;

my ($lo, $hi) = ($cod[0], $cod[0]);
foreach (@cod) {
    $lo = $_ unless $lo < $_;
    $hi = $_ unless $hi > $_;
}

print STDERR scalar @cod, " values loaded, lo = $lo, hi = $hi\n";

$lo = int(&floor($lo));
$hi = int(&ceil($hi));

my %bins;
for (my $x = $lo; $x <= $hi; $x += 2) {
    $bins{$x} = 0.0;
}

foreach (@cod) {
    my $x = int($_ + 0.5*($_ <=> 0.0));
    if (not exists($bins{$x})) {
#        print STDERR "<> strange value: $_ => bin #$x\n";
        next;
    }
    $bins{$x} += 1.0;
}

my $total = 0.0;
foreach (keys %bins) {
    $total += $bins{$_};
}

for (my $x = $lo; $x <= $hi; $x += 2) {
    printf "%2d %.10f\n", $x, $bins{$x}/$total;
}
